/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.viewer3d.controls;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Window;
import java.io.BufferedReader;
import java.io.File;
import java.io.FilenameFilter;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import org.visnow.vn.geometries.viewer3d.Display3DPanel;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class MovieCreationPanel extends javax.swing.JPanel
{

    private File workDir = new File("/tmp");
    private String baseWorkFileName = "/tmp/";
    private int currentFrame = 0;
    private static DecimalFormat intf = new DecimalFormat("000000");
    private String cmdline = "echo test";
    private Display3DPanel panel = null;
    private int width = 0;
    private int height = 0;
    private String currentFrameFileName = null;
    private int[][] resolutions
        = {{-1, -1}, //dummy values corresponding to "choose resolution ..." entry
           {640, 480},
           {800, 600},
           {1024, 768},
           {1600, 1200},
           {1280, 1024},
           {852, 480},
           {1280, 720},
           {1920, 1080},
           {2560, 1440},
           {3840, 2160}};

    /**
     * Creates new form MovieCreationPanel
     */
    public MovieCreationPanel()
    {
        initComponents();
        formatGroup.add(jpegToggle);
        formatGroup.add(pngToggle);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        dirChooser = new javax.swing.JFileChooser();
        formatGroup = new javax.swing.ButtonGroup();
        mpegInfoFrame = new javax.swing.JFrame();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        mpegSysOutLabel = new javax.swing.JLabel();
        clearAndCloseButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jPanel4 = new javax.swing.JPanel();
        mpegSysErrLabel = new javax.swing.JLabel();
        storeToggle = new javax.swing.JToggleButton();
        clearButton = new javax.swing.JButton();
        currentFileLabel = new javax.swing.JLabel();
        currentFileField = new javax.swing.JTextField();
        compileButton = new javax.swing.JButton();
        movieNameField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        workDirButton = new javax.swing.JButton();
        clearTmpButton = new javax.swing.JButton();
        resolutionsCombo = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jpegToggle = new javax.swing.JRadioButton();
        pngToggle = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        qualitySlider = new org.visnow.vn.gui.widgets.ExtendedSlider();

        dirChooser.setCurrentDirectory(new java.io.File("/tmp"));
        dirChooser.setDialogTitle("movie work directory");
        dirChooser.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

        mpegInfoFrame.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        mpegInfoFrame.getContentPane().setLayout(new java.awt.GridBagLayout());

        jPanel3.setLayout(new java.awt.BorderLayout());

        mpegSysOutLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mpegSysOutLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        mpegSysOutLabel.setMaximumSize(new java.awt.Dimension(300, 400));
        jPanel3.add(mpegSysOutLabel, java.awt.BorderLayout.CENTER);

        jScrollPane1.setViewportView(jPanel3);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        mpegInfoFrame.getContentPane().add(jScrollPane1, gridBagConstraints);

        clearAndCloseButton.setText("clear temporary files and close");
        clearAndCloseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearAndCloseButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        mpegInfoFrame.getContentPane().add(clearAndCloseButton, gridBagConstraints);

        closeButton.setText("close");
        closeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                closeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        mpegInfoFrame.getContentPane().add(closeButton, gridBagConstraints);

        jPanel4.setLayout(new java.awt.BorderLayout());

        mpegSysErrLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mpegSysErrLabel.setForeground(new java.awt.Color(153, 0, 0));
        mpegSysErrLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        mpegSysErrLabel.setMaximumSize(new java.awt.Dimension(300, 400));
        jPanel4.add(mpegSysErrLabel, java.awt.BorderLayout.CENTER);

        jScrollPane2.setViewportView(jPanel4);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        mpegInfoFrame.getContentPane().add(jScrollPane2, gridBagConstraints);

        setLayout(new java.awt.GridBagLayout());

        storeToggle.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        storeToggle.setText("store frames");
        storeToggle.setEnabled(false);
        storeToggle.setMargin(new java.awt.Insets(2, 2, 2, 2));
        storeToggle.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                storeToggleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(storeToggle, gridBagConstraints);

        clearButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        clearButton.setText("clear frames");
        clearButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        clearButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(clearButton, gridBagConstraints);

        currentFileLabel.setText("current frame");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 6);
        add(currentFileLabel, gridBagConstraints);

        currentFileField.setText("null");
        currentFileField.setMinimumSize(new java.awt.Dimension(4, 24));
        currentFileField.setPreferredSize(new java.awt.Dimension(300, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(currentFileField, gridBagConstraints);

        compileButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        compileButton.setText("compile movie");
        compileButton.setEnabled(false);
        compileButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                compileButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 1.0;
        add(compileButton, gridBagConstraints);

        movieNameField.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        movieNameField.setText("movie.mp4");
        movieNameField.setMinimumSize(new java.awt.Dimension(4, 24));
        movieNameField.setPreferredSize(new java.awt.Dimension(63, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(movieNameField, gridBagConstraints);

        jLabel2.setText("movie file");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 6);
        add(jLabel2, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridLayout(1, 0));

        workDirButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        workDirButton.setText("work directory");
        workDirButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        workDirButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                workDirButtonActionPerformed(evt);
            }
        });
        jPanel2.add(workDirButton);

        clearTmpButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        clearTmpButton.setText("clear tmp files");
        clearTmpButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        clearTmpButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearTmpButtonActionPerformed(evt);
            }
        });
        jPanel2.add(clearTmpButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jPanel2, gridBagConstraints);

        resolutionsCombo.setMaximumRowCount(11);
        resolutionsCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "choose resolution ...", "vga (640x480)", "svga (800x600)", "xga (1024x768)", "uxga (1600x1200)", "sxga (1280x1024)", "480p (852x480)", "720p (1280x720)", "1080p (1920x1080)", "1440p (2560x1440)", "4k (3840x2160)" }));
        resolutionsCombo.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "movie resolution", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        resolutionsCombo.setPreferredSize(new java.awt.Dimension(140, 48));
        resolutionsCombo.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resolutionsComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 3, 0);
        add(resolutionsCombo, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jpegToggle.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        jpegToggle.setSelected(true);
        jpegToggle.setText("jpeg");
        jpegToggle.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 3, 0);
        jPanel1.add(jpegToggle, gridBagConstraints);

        pngToggle.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        pngToggle.setText("png");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 3, 0);
        jPanel1.add(pngToggle, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);

        jLabel1.setText("quality factor");
        jLabel1.setToolTipText("Constant Rate Factor (CRF) for H.264 encoder. The higher the rate factor the lower the quality. Use 0 for lossless compression.  ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 6);
        add(jLabel1, gridBagConstraints);

        qualitySlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.BYTE);
        qualitySlider.setGlobalMax(51);
        qualitySlider.setGlobalMin(0);
        qualitySlider.setMax(51);
        qualitySlider.setMin(0);
        qualitySlider.setShowFieldsButtonVisible(false);
        qualitySlider.setValue(17);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(qualitySlider, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void clearTmpFiles()
    {
        String[] tmpFileList = workDir.list(new FilenameFilter()
        {
            public boolean accept(File dir, String name)
            {
                if (name.endsWith(".jpg") || name.endsWith(".png"))
                    return true;
                return false;
            }
        });
        for (int i = 0; i < tmpFileList.length; i++) {
            File f = new File(baseWorkFileName + tmpFileList[i]);
            if (f.exists())
                f.delete();
        }
    }

    private void clearTmpButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clearTmpButtonActionPerformed
    {//GEN-HEADEREND:event_clearTmpButtonActionPerformed
        clearTmpFiles();
    }//GEN-LAST:event_clearTmpButtonActionPerformed

    private void compileButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_compileButtonActionPerformed
    {//GEN-HEADEREND:event_compileButtonActionPerformed
        int idx = resolutionsCombo.getSelectedIndex();
        if(idx > 0) {
            int crf = qualitySlider.getValue().intValue();
            String fileName = jpegToggle.isSelected() ? "%06d.jpg " : "%06d.png ";
            cmdline = "ffmpeg -i " + baseWorkFileName + fileName
                    + "-c:v libx264 -crf " + crf + " "
                    + "-vf scale=" + width + "x" + height + " "
                    + "-y " + workDir + File.separator + movieNameField.getText();
            mpegInfoFrame.setSize(500, 300);
            mpegInfoFrame.setVisible(true);
            new Thread(() -> {
                String line;
                StringBuilder outStr = new StringBuilder("<html><font color=\"blue\">executing </font> " + cmdline);
                StringBuilder errStr = new StringBuilder("<html>");
                mpegSysOutLabel.setText(outStr.toString() + "</html>");
                Process p;
                try {
                    p = Runtime.getRuntime().exec(cmdline);
                } catch (Throwable ex) {
                    mpegSysErrLabel.setText("<html>An exception occurred while executing " + cmdline + "</html>");
                    return;
                }
                try (BufferedReader input = new BufferedReader(new InputStreamReader(p.getInputStream()));
                        BufferedReader errorInput = new BufferedReader(new InputStreamReader(p.getErrorStream()))) {
                    while ((line = input.readLine()) != null) {
                        outStr.append("<p>").append(line);
                        mpegSysOutLabel.setText(outStr.toString() + "</html>");
                    }
                    while ((line = errorInput.readLine()) != null) {
                        errStr.append("<p>").append(line);
                        mpegSysErrLabel.setText(errStr.toString() + "</html>");
                    }
                    outStr.append("<p><font color=\"blue\">exit ").append(p.exitValue()).append("</font>");
                    mpegSysOutLabel.setText(outStr.toString() + "</html>");
                } catch (Throwable err) {
                    mpegSysErrLabel.setText("<html>An exception occurred while executing " + cmdline + "</html>");
                }
            }).start();
        }
    }//GEN-LAST:event_compileButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clearButtonActionPerformed
    {//GEN-HEADEREND:event_clearButtonActionPerformed
        currentFrame = 0;
    }//GEN-LAST:event_clearButtonActionPerformed

    private void storeToggleActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_storeToggleActionPerformed
    {//GEN-HEADEREND:event_storeToggleActionPerformed
        if (storeToggle.isSelected()) {
            currentFrame = 0;
            Dimension size = new Dimension(width, height);
            panel.setMinimumSize(size);
            panel.setMaximumSize(size);
            panel.setPreferredSize(size);
            panel.setSize(size);
            Container p = panel.getParent();
            while (!(p instanceof Window)) {
                p = p.getParent();
            };
            ((Window) p).pack();
            panel.newOffScreen();
            panel.setStoringFrames(true);
            panel.setStoringJPEG(jpegToggle.isSelected());
            panel.setStoringPNG(pngToggle.isSelected());
        } else {
            panel.clearOffScreen();
            panel.setStoringFrames(false);
        }
    }//GEN-LAST:event_storeToggleActionPerformed

    private void workDirButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_workDirButtonActionPerformed
    {//GEN-HEADEREND:event_workDirButtonActionPerformed
        if (dirChooser.showDialog(null, "Select") == dirChooser.APPROVE_OPTION) {
            boolean success = (dirChooser.getSelectedFile().isDirectory() ||
                (new File(dirChooser.getSelectedFile().getAbsolutePath()).mkdirs()));
            if (success) {
                workDir = new File(dirChooser.getSelectedFile().getAbsolutePath());
                baseWorkFileName = dirChooser.getSelectedFile().getAbsolutePath() + "/";
                currentFileField.setText(baseWorkFileName);
            } else
                System.out.println("could not find or create directory " + dirChooser.getSelectedFile().getAbsolutePath());
        }
    }//GEN-LAST:event_workDirButtonActionPerformed

    private void resolutionsComboActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resolutionsComboActionPerformed
    {//GEN-HEADEREND:event_resolutionsComboActionPerformed
        int idx = resolutionsCombo.getSelectedIndex();
        if (idx > 0) {
            width = resolutions[idx][0];
            height = resolutions[idx][1];
            updatePanelSize();
            storeToggle.setEnabled(true);
            compileButton.setEnabled(true);
        }
        else {
            width = -1;
            height = -1;
            storeToggle.setEnabled(false);
            compileButton.setEnabled(false);
        }
    }//GEN-LAST:event_resolutionsComboActionPerformed

    private void clearAndCloseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clearAndCloseButtonActionPerformed
    {//GEN-HEADEREND:event_clearAndCloseButtonActionPerformed
        clearTmpFiles();
        mpegInfoFrame.setVisible(false);
    }//GEN-LAST:event_clearAndCloseButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_closeButtonActionPerformed
    {//GEN-HEADEREND:event_closeButtonActionPerformed
        mpegInfoFrame.setVisible(false);
    }//GEN-LAST:event_closeButtonActionPerformed

    public void setCurrentFrame(int currentFrame)
    {
        this.currentFrame = currentFrame;
        if (jpegToggle.isSelected())
            currentFileField.setText(baseWorkFileName + intf.format((long) currentFrame) + ".jpg");
        else
            currentFileField.setText(baseWorkFileName + intf.format((long) currentFrame) + ".png");
    }

    public Display3DPanel getPanel()
    {
        return panel;
    }

    public void setPanel(Display3DPanel panel)
    {
        this.panel = panel;
    }

    public String getCurrentFrameFileName()
    {
        if (jpegToggle.isSelected())
            currentFrameFileName = baseWorkFileName + intf.format((long) currentFrame) + ".jpg";
        else
            currentFrameFileName = baseWorkFileName + intf.format((long) currentFrame) + ".png";
        currentFileField.setText(currentFrameFileName);
        currentFrame += 1;
        return currentFrameFileName;
    }

    public String getGenericFrameFileName()
    {
        return baseWorkFileName;
    }

    public int getCurrentFrameNumber()
    {
        int c = currentFrame;
        if (jpegToggle.isSelected())
            currentFrameFileName = baseWorkFileName + intf.format((long) currentFrame) + ".jpg";
        else
            currentFrameFileName = baseWorkFileName + intf.format((long) currentFrame) + ".png";
        currentFileField.setText(currentFrameFileName);
        currentFrame += 1;
        return c;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearAndCloseButton;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton clearTmpButton;
    private javax.swing.JButton closeButton;
    private javax.swing.JButton compileButton;
    private javax.swing.JTextField currentFileField;
    private javax.swing.JLabel currentFileLabel;
    private javax.swing.JFileChooser dirChooser;
    private javax.swing.ButtonGroup formatGroup;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JRadioButton jpegToggle;
    private javax.swing.JTextField movieNameField;
    private javax.swing.JFrame mpegInfoFrame;
    private javax.swing.JLabel mpegSysErrLabel;
    private javax.swing.JLabel mpegSysOutLabel;
    private javax.swing.JRadioButton pngToggle;
    private org.visnow.vn.gui.widgets.ExtendedSlider qualitySlider;
    private javax.swing.JComboBox resolutionsCombo;
    private javax.swing.JToggleButton storeToggle;
    private javax.swing.JButton workDirButton;
    // End of variables declaration//GEN-END:variables
    private void updatePanelSize()
    {
        if(width > 0 && height > 0) {
            Dimension size = new Dimension(width, height);
            panel.setMinimumSize(size);
            panel.setMaximumSize(size);
            panel.setPreferredSize(size);
            panel.setSize(size);
            Container p = panel.getParent();
            while (!(p instanceof Window)) {
                p = p.getParent();
            }
            ((Window) p).pack();
        }
    }
}
